/**
 * watermap Mercator Point Raster to CSV 
 * 
 */

PImage img;
Table table;

double radius_e = 6378137.0; /* in meters on the equator */

int pointSize = 36, actSize, count;
int rasterWidth, rasterHeight;
double lat, lon;
boolean firstrun=true;
float r_major = 6378137.0;             //Equatorial Radius, WGS84
float r_minor= 6356752.3142459;      //defined as constant
float f=298.257223563;                 //1/f=(a-b)/a , a=r_major, b=r_minor

float x0=849;
float y0=835;

void setup() {
  size(1824, 1231);
  noFill();
  stroke(255);
  frameRate(60);
  img = loadImage("Mercator.png");

  table = new Table();

  table.addColumn("id");
  table.addColumn("lat");
  table.addColumn("long");
}

void draw()
{
  background(0);
  image(img, 0, 0, width, height);

  rasterWidth = width/pointSize;
  rasterHeight = height/pointSize;
  for (int j=rasterWidth; j>0; j--) {
    for (int i=0; i<rasterHeight; i++) {
      color c = img.get(j*pointSize+pointSize/2, i*pointSize+pointSize/2);
      if ( brightness(c)>10)
      {
        actSize =  pointSize;
        if (firstrun==true)
        {
          float x1=x0-(j*pointSize+pointSize/2.0);
          float y1=(y0-(i*pointSize+pointSize/2.0));

          lat=y2lat((y1)*22000);
          lon=x2lon((x1)*-22000);

          TableRow newRow = table.addRow();
          newRow.setInt("id", table.getRowCount() - 1);
          newRow.setDouble("lat", lat);
          newRow.setDouble("long", lon);
        }
      } else
      {
        actSize=0;
      }

      fill(255);
      ellipse(j*pointSize+pointSize/2.0, i*pointSize+pointSize/2.0, actSize, actSize);
    }
  }
  if (firstrun==true)
  {
    saveTable(table, "data/points.csv");
    firstrun=false;
  }
}

void keyPressed() {
  if (key == CODED) {
    if (keyCode == LEFT && pointSize>4) {
      pointSize--;
    } else if (keyCode == RIGHT && pointSize<width/4) {
      pointSize++;
    }
  }
  saveTable(table, "data/points.csv");
}

double y2lat(double aY) {
  return (180/PI)*(Math.atan(Math.exp(aY / radius_e)) * 2 - Math.PI/2);
}
double x2lon(double aX) {
  return (180/PI)*(aX / radius_e);
}